
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JUnit和单元测试入门简介 / iVAN</title>

    <meta name="description" content="JUnit和单元测试入门简介 JUnit和单元测试入门简介 1.几个相关的概念 白盒测试--把测试对象看作一个打开的盒子,程序内部的逻辑结构和其他信息对测试人员是公开的. 回归测试--软件或环境的修复或更正后的&quot;再测试&quot;,自动测试工具对这类测试尤其有用. 单元测试--是最小粒度的测试,以测试某个功能或代码块.一般由程序员来做,因为它需要知道内部程序设计和编码的细节. JUnit --是一个开发源代码的Java测试框架,用于编写和运行可重复的测试.他是用于单元测试框架体系xUnit的一个实例(用于java语 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">JUnit和单元测试入门简介</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>JUnit和单元测试入门简介</p>
<p>1、几个相关的概念</p>
<p>白盒测试——把测试对象看作一个打开的盒子，程序内部的逻辑结构和其他信息对测试人员是公开的。</p>
<p>回归测试——软件或环境的修复或更正后的“再测试”，自动测试工具对这类测试尤其有用。</p>
<p>单元测试——是最小粒度的测试，以测试某个功能或代码块。一般由程序员来做，因为它需要知道内部程序设计和编码的细节。</p>
<p>JUnit ——是一个开发源代码的Java测试框架，用于编写和运行可重复的测试。他是用于单元测试框架体系xUnit的一个实例（用于java语言）。主要用于白盒测试，回归测试。</p>
<p>2、单元测试概述</p>
<p>2.1、单元测试的好处</p>
<p>A、提高开发速度——测试是以自动化方式执行的，提升了测试代码的执行效率。</p>
<p>B、提高软件代码质量——它使用小版本发布至集成，便于实现人员除错。同时引入重构概念，让代码更干净和富有弹性。</p>
<p>C、提升系统的可信赖度——它是回归测试的一种。支持修复或更正后的“再测试”，可确保代码的正确性。</p>
<p>2．2、单元测试的针对对象</p>
<p>A、面向过程的软件开发针对过程。</p>
<p>B、面向对象的软件开发针对对象。</p>
<p>C、可以做类测试，功能测试，接口测试（最常用于测试类中的方法）。</p>
<p>2.3、单元测试工具和框架</p>
<p>目前的最流行的单元测试工具是xUnit系列框架，常用的根据语言不同分为JUnit（java），CppUnit（C++），DUnit （Delphi ），NUnit（.net），PhpUnit（Php ）等等。该测试框架的第一个和最杰出的应用就是由Erich Gamma （《设计模式》的作者）和Kent Beck（XP（Extreme Programming）的创始人 ）提供的开放源代码的JUnit。</p>
<p>3.Junit入门简介</p>
<p>3.1、JUnit的好处和JUnit单元测试编写原则</p>
<p>好处：</p>
<p>A、可以使测试代码与产品代码分开。</p>
<p>B、针对某一个类的测试代码通过较少的改动便可以应用于另一个类的测试。</p>
<p>C、易于集成到测试人员的构建过程中，JUnit和Ant的结合可以实施增量开发。</p>
<p>D、JUnit是公开源代码的，可以进行二次开发。</p>
<p>C、可以方便地对JUnit进行扩展。</p>
<p>编写原则：</p>
<p>A、是简化测试的编写，这种简化包括测试框架的学习和实际测试单元的编写。</p>
<p>B、是使测试单元保持持久性。</p>
<p>C、是可以利用既有的测试来编写相关的测试。</p>
<p>3.2、JUnit的特征</p>
<p>A、使用断言方法判断期望值和实际值差异，返回Boolean值。</p>
<p>B、测试驱动设备使用共同的初始化变量或者实例。</p>
<p>C、测试包结构便于组织和集成运行。</p>
<p>D、支持图型交互模式和文本交互模式。</p>
<p>3.3、JUnit框架组成</p>
<p>A、对测试目标进行测试的方法与过程集合，可称为测试用例(TestCase)。</p>
<p>B、测试用例的集合，可容纳多个测试用例(TestCase)，将其称作测试包(TestSuite)。</p>
<p>C、测试结果的描述与记录。(TestResult) 。</p>
<p>D、测试过程中的事件监听者(TestListener)。</p>
<p>E、每一个测试方法所发生的与预期不一致状况的描述，称其测试失败元素(TestFailure)</p>
<p>F、JUnit Framework中的出错异常（AssertionFailedError）。</p>
<p>JUnit框架是一个典型的Composite模式：TestSuite可以容纳任何派生自Test的对象；当调用TestSuite对象的run()方法是，会遍历自己容纳的对象，逐个调用它们的run()方法。（可参考《程序员》2003-6期）。</p>
<p>3.4、JUnit的安装和配置</p>
<p>JUnit安装步骤分解：</p>
<p>在http://download.sourceforge.net/junit/中下载JUnit包并将Junit压缩包解压到一个物理目录中（例如C：＼Junit3.8.1）。 <br />记录Junit.jar文件所在目录名（例如C：＼Junit3.8.1\Junit.jar）。 <br />进入操作系统（以Windows2000操作系统为准），按照次序点击“开始　设置　控制面板”。 <br />在控制面板选项中选择“系统”，点击“环境变量”，在“系统变量”的“变量”列表框中选择“CLASS-PATH”关键字（不区分大小写），如果该关键字不存在则添加。 <br />双击“CLASS-PATH”关键字添加字符串“C:＼Junit3.8.1\Junti.jar”(注意，如果已有别的字符串请在该字符串的字符结尾加上分号“；”)，这样确定修改后Junit就可以在集成环境中应用了。 <br />对于IDE环境，对于需要用到的JUnit的项目增加到lib中，其设置不同的IDE有不同的设置 。<br />3.5、JUnit中常用的接口和类</p>
<p>Test接口——运行测试和收集测试结果</p>
<p>Test接口使用了Composite设计模式，是单独测试用例 （TestCase），聚合测试模式（TestSuite）及测试扩展（TestDecorator）的共同接口。 <br />它的public int countTestCases（）方法，它来统计这次测试有多少个TestCase，另外一个方法就是public void　run（ TestResult ），TestResult是实例接受测试结果， run方法执行本次测试。<br />TestCase抽象类——定义测试中固定方法</p>
<p>TestCase是Test接口的抽象实现，（不能被实例化，只能被继承）其构造函数TestCase(string name)根据输入的测试名称name创建一个测试实例。由于每一个TestCase在创建时都要有一个名称，若某测试失败了，便可识别出是哪个测试失败。 <br />TestCase类中包含的setUp()、tearDown()方法。setUp()方法集中初始化测试所需的所有变量和实例，并且在依次调用测试类中的每个测试方法之前再次执行setUp()方法。tearDown()方法则是在每个测试方法之后，释放测试程序方法中引用的变量和实例。 <br /> 开发人员编写测试用例时，只需继承TestCase，来完成run方法即可，然后JUnit获得测试用例，执行它的run方法，把测试结果记录在TestResult之中。<br />Assert静态类——一系列断言方法的集合</p>
<p>Assert包含了一组静态的测试方法，用于期望值和实际值比对是否正确，即测试失败，Assert类就会抛出一个AssertionFailedError异常，JUnit测试框架将这种错误归入Failes并加以记录，同时标志为未通过测试。如果该类方法中指定一个String类型的传参则该参数将被做为AssertionFailedError异常的标识信息，告诉测试人员改异常的详细信息。 <br />JUnit 提供了6大类31组断言方法，包括基础断言、数字断言、字符断言、布尔断言、对象断言。 <br />其中assertEquals（Object expcted,Object actual)内部逻辑判断使用equals()方法，这表明断言两个实例的内部哈希值是否相等时，最好使用该方法对相应类实例的值进行比较。而assertSame（Object expected,Object actual）内部逻辑判断使用了Java运算符“==”，这表明该断言判断两个实例是否来自于同一个引用（Reference），最好使用该方法对不同类的实例的值进行比对。asserEquals(String message,String expected,String actual)该方法对两个字符串进行逻辑比对，如果不匹配则显示着两个字符串有差异的地方。ComparisonFailure类提供两个字符串的比对，不匹配则给出详细的差异字符。<br />TestSuite测试包类——多个测试的组合</p>
<p>TestSuite类负责组装多个Test Cases。待测得类中可能包括了对被测类的多个测试，而TestSuit负责收集这些测试，使我们可以在一个测试中，完成全部的对被测类的多个测试。 <br />TestSuite类实现了Test接口，且可以包含其它的TestSuites。它可以处理加入Test时的所有抛出的异常。 <br />TestSuite处理测试用例有6个规约（否则会被拒绝执行测试）<br />        A 测试用例必须是公有类（Public）</p>
<p>B 测试用例必须继承与TestCase类</p>
<p>C 测试用例的测试方法必须是公有的（ Public ）</p>
<p>D 测试用例的测试方法必须被声明为Void</p>
<p>E 测试用例中测试方法的前置名词必须是test</p>
<p>F 测试用例中测试方法误任何传递参数</p>
<p>n       TestResult结果类和其它类与接口</p>
<p>TestResult结果类集合了任意测试累加结果，通过TestResult实例传递个每个测试的Run（）方法。TestResult在执行TestCase是如果失败会异常抛出 <br />TestListener接口是个事件监听规约，可供TestRunner类使用。它通知listener的对象相关事件，方法包括测试开始startTest(Test test)，测试结束endTest(Test test),错误，增加异常addError(Test test,Throwable t)和增加失败addFailure(Test test,AssertionFailedError t) <br />TestFailure失败类是个“失败”状况的收集类，解释每次测试执行过程中出现的异常情况。其toString()方法返回“失败”状况的简要描述</p>
<p>3.6、JUnit一个实例</p>
<p>在控制台中简单的范例如下：<br />1、写个待测试的Triangle类，创建一个TestCase的子类ExampleTest: <br />2、 ExampleTest中写一个或多个测试方法，断言期望的结果(注意：以test作为待测试的方法的开头，这样这些方法可以被自动找到并被测试)<br />3、 ExampleTest中写一个suite()方法，它会使用反射动态的创建一个包含所有的testXxxx方法的测试套件：<br />4、 ExampleTest可以写setUp()、tearDown()方法，以便于在测试时初始化或销毁测试所需的所有变量和实例。（不是必须的）</p>
<p>5、写一个main()方法以文本运行器或其它GUI的方式方便的运行测试</p>
<p>6、编译ExampleTest，执行测试。</p>
<p>3.7、Eclipse中JUnit的使用</p>
<p>Eclipse自带了一个JUnit的插件，不用安装就可以在你的项目中开始测试相关的类，并且可以调试你的测试用例和被测试类。</p>
<p>使用步骤如下：</p>
<p>1、新建一个测试用例，点击“File-&gt;New-&gt;Other…菜单项，在弹出的“New”对话框中选择”Java-&gt;JUnit”,下的TestCase 或TestSuite，就进入“New JUnit TestCase”对话框</p>
<p>2、在“New JUnit TestCase”对话框填写相应的栏目，主要有Name（测试用例名），SuperClass（测试的超类一般是默认的junit.framework.TestCase），Class Under Test（被测试的类），Source Folder（测试用例保存的目录），Package（测试用例包名），及是否自动生成main,setUp,tearDown方法。</p>
<p>3、如果点击下面的”Next&gt;”按钮，你还可以直接勾选你想测试的被测试类的方法，Eclipse将自动生成与被选方法相应的测试方法，点击“Fishish”按钮后一个测试用例就创建好了。</p>
<p>4、编写完成你的测试用例后，点击“Run”按钮就可以看到运行结果了。</p>
<p>3.8、JUnit的扩展应用</p>
<p>以下罗列了些JUnit的扩展应用：</p>
<p>JUnit + HttpUnit=WEB功能测试工具<br />   JUnit + hansel =代码覆盖测试工具<br />   JUnit + abbot =界面自动回放测试工具<br />   JUnit + dbunit =数据库测试工具<br />   JUnit + junitperf=性能测试工具</p>
<p>3.9、一些使用JUnit经验</p>
<p>不要用TestCase的构造函数初始化，而要用setUp()和tearDown()方法。 <br />不要依赖或假定测试运行的顺序，因为JUnit利用Vector保存测试方法。所以不同的平台会按不同的顺序从Vector中取出测试方法。 <br />避免编写有副作用的TestCase。例如：如果随后的测试依赖于某些特定的交易数据，就不要提交交易数据。简单的回滚就可以了。 <br />当继承一个测试类时，记得调用父类的setUp()和tearDown()方法。 <br />将测试代码和工作代码放在一起，一边同步编译和更新。 <br />测试类和测试方法应该有一致的命名方案。如在工作类名前加上test从而形成测试类名。 <br />确保测试与时间无关，不要依赖使用过期的数据进行测试。导致在随后的维护过程中很难重现测试。 <br />如果你编写的软件面向国际市场，编写测试时要考虑国际化的因素。不要仅用母语的Locale进行测试。 <br />尽可能地利用JUnit提供地assert/fail方法以及异常处理的方法，可以使代码更为简洁。 <br />测试要尽可能地小，执行速度快。</p>
<p>参考资料与附件</p>
<p>1.         http:// www.junit.org JUnit官方网站</p>
<p>2.         http://bbs.51cmm.com  的测试论坛</p>
<p>3.         http://www.uml.org.cn 的软件测试专栏</p>
<p>4.         单元测试   《程序员》  2002年7期</p>
<p>5.         JUnit设计模式分析    《程序员》2003年6期</p>
<p>6.         《软件测试和JUnit实践》</p>
<p>7.         附件Triangle.java 一个要测试的类</p>
<p>8.         附件ExampleTest.java 一个测试用例类</p>
<p>Triangle.java</p>
<p>/**</p>
<p>* this is Triangle class</p>
<p>* @author liujun</p>
<p>*/</p>
<p>public class Triangle</p>
<p>{</p>
<p>//定义三角形的三边</p>
<p>protected long lborderA = 0;</p>
<p>protected long lborderB = 0;</p>
<p>protected long lborderC = 0;</p>
<p>//构造函数</p>
<p>public Triangle(long lborderA,long lborderB,long lborderC)</p>
<p>{</p>
<p>this.lborderA = lborderA;</p>
<p>this.lborderB = lborderB;</p>
<p>this.lborderC = lborderC;</p>
<p>}</p>
<p>/**</p>
<p>* 判断是否是三角形</p>
<p>* 是返回ture；不是返回false</p>
<p>*/</p>
<p>public  boolean isTriangle(Triangle triangle)</p>
<p>{</p>
<p>boolean isTrue = false;</p>
<p>//判断边界，大于0小于200，出界返回false</p>
<p>if((triangle.lborderA&gt;0&amp;&amp;triangle.lborderA&lt;200)</p>
<p>&amp;&amp;(triangle.lborderB&gt;0&amp;&amp;triangle.lborderB&lt;200)</p>
<p>&amp;&amp;(triangle.lborderC&gt;0&amp;&amp;triangle.lborderC&lt;200))</p>
<p>{</p>
<p>//判断两边之和大于第三边</p>
<p>if((triangle.lborderA&lt;(triangle.lborderB+triangle.lborderC))</p>
<p>&amp;&amp;(triangle.lborderB&lt;(triangle.lborderA+triangle.lborderC))</p>
<p>&amp;&amp;(triangle.lborderC&lt;(triangle.lborderA+triangle.lborderB)))</p>
<p>isTrue = true;</p>
<p>}</p>
<p>return isTrue;</p>
<p>}</p>
<p>/**</p>
<p>* 判断三角形类型</p>
<p>* 等腰三角形返回字符串“等腰三角形”；</p>
<p>* 等边三角形返回字符串“等边三角形”；</p>
<p>* 其它三角形返回字符串“不等边三角形”；</p>
<p>*/</p>
<p>public String isType(Triangle triangle)</p>
<p>{</p>
<p>String strType = "";</p>
<p>// 判断是否是三角形</p>
<p>if(this.isTriangle(triangle))</p>
<p>{</p>
<p>//判断是否是等边三角形                  if(triangle.lborderA==triangle.lborderB&amp;&amp;triangle.lborderB==triangle.lborderC)</p>
<p>strType = "等边三角形";</p>
<p>//判断是否是不等边三角形</p>
<p>else if((triangle.lborderA!=triangle.lborderB)&amp;&amp;</p>
<p>(triangle.lborderB!=triangle.lborderC)&amp;&amp;</p>
<p>(triangle.lborderA!=triangle.lborderC))</p>
<p>strType = "不等边三角形";</p>
<p>else</p>
<p>strType="等腰三角形";</p>
<p>}</p>
<p>return strType;</p>
<p>}</p>
<p>}</p>
<p>ExampleTest.java</p>
<p>import junit.framework.*;</p>
<p>/**</p>
<p>* Some tests.</p>
<p>*</p>
<p>*/</p>
<p>public class ExampleTest extends TestCase {</p>
<p>public Triangle triangle;</p>
<p>//初始化</p>
<p>protected void setUp() {</p>
<p>triangle=new Triangle(10,2,9);</p>
<p>}</p>
<p>public static Test suite() {</p>
<p>return new TestSuite(ExampleTest.class);</p>
<p>}</p>
<p>//函数isTriangle()的测试用例</p>
<p>public void testIsTriangle() {</p>
<p>assertTrue(triangle.isTriangle(triangle));</p>
<p>}</p>
<p>//函数isType()的测试用例</p>
<p>public void testIsType()</p>
<p>{</p>
<p>assertEquals("这次测试",triangle.isType(triangle),"不等边三角形");</p>
<p>}</p>
<p>//执行测试</p>
<p>public static void main (String[] args) {</p>
<p>//文本方式</p>
<p>junit.textui.TestRunner.run(suite());</p>
<p>//Swingui方式</p>
<p>//junit.swingui.TestRunner.run(suite().getClass());</p>
<p>//awtui方式</p>
<p>//junit.awtui.TestRunner.run(suite().getClass());</p>
<p>}</p>
<p>}</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 18:30:09</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e5%ae%9e%e4%be%8b/" title="实例">实例</a>, <a href="https://www.iamivan.net/tag/junit/" title="junit">junit</a>, <a href="https://www.iamivan.net/tag/%e5%8d%95%e5%85%83%e6%b5%8b%e8%af%95/" title="单元测试">单元测试</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd%e6%b5%8b%e8%af%95/" title="性能测试">性能测试</a>, <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95%e5%b7%a5%e5%85%b7/" title="测试工具">测试工具</a>, <a href="https://www.iamivan.net/tag/%e5%8e%8b%e5%8a%9b%e6%b5%8b%e8%af%95/" title="压力测试">压力测试</a>, <a href="https://www.iamivan.net/tag/junit%e6%b5%8b%e8%af%95/" title="junit测试">junit测试</a>, <a href="https://www.iamivan.net/tag/java-spring3-0-junit/" title="java spring3 0 junit">java spring3 0 junit</a>, <a href="https://www.iamivan.net/tag/%e8%bd%af%e4%bb%b6%e6%b5%8b%e8%af%95/" title="软件测试">软件测试</a>, <a href="https://www.iamivan.net/tag/%e7%94%a8%e4%be%8b%e6%89%a7%e8%a1%8c%e9%a1%ba%e5%ba%8f/" title="用例执行顺序">用例执行顺序</a>, <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95%e7%b1%bb/" title="测试类">测试类</a>, <a href="https://www.iamivan.net/tag/python%e6%8e%a5%e5%8f%a3%e6%b5%8b%e8%af%95assert%e6%96%ad%e8%a8%80/" title="python接口测试assert断言">python接口测试assert断言</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>JUnit和单元测试入门简介的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRY45qb.html" rel="bookmark">JUnit &plus; Mockito 单元测试（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				未接触 JUnit 之前,曾经对茫茫的代码不知所措--哪怕是自己写的--多写注释?重构代码?甚至为一个方法去写一篇技术文章来解释?--这些都是试过,感觉不是&quot;控制代码&quot;的可行之道,甚至说&quot;徒劳&quot;的.关于单元测试(Unit test),之前亦略有所闻,感觉用处不大,因为对一个方法检测返回的结果是否正确,--有点无聊--心想,我写的方法当然能返回预期的结果,这还有说?不至于那么低级的错误也犯得着吧!?于是对所谓测试的东东感觉简直就是在增加工作量--我把代码写漂亮点就行了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQBj5OM.html" rel="bookmark">JUnit &plus; Mockito 单元测试（二）&lpar;good&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  import org.junit.Test; import org.mockito.Matchers; import org.mockito.Mockito; import java.util.List; import java.util.Map; import static org.hamcrest.CoreMatchers.is; import static org.hamcrest.MatcherAssert.assertThat; import static org.mockito.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z76GDZp.html" rel="bookmark">JUnit &plus; Mockito 单元测试（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JUnit 是单元测试框架.Mockito 与 JUnit 不同,并不是单元测试框架(这方面 JUnit 已经足够好了),它是用于生成模拟对象或者直接点说,就是&quot;假对象&quot;的工具.两者定位不同,所以一般通常的做法就是联合 JUnit + Mockito 来进行测试. 入门 首先是配置 Mock 对象,看看例子怎么写的. List mock = mock( List.class ); when( mock.get(0) ).thenReturn( 1 ); assertEquals( &q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMlONLb.html" rel="bookmark">Eclipse学习4－在Eclipse中使用JUnit进行单元测试（上）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用JUnit进行测试 JUnit是与Eclipse一起提供的一个开源测试框架.在同一个Project中,可以创建与其它class无异的&quot;基于JUnit&quot;的class,并使用此JUnit代码去测试project中的其它class.JUnit的此种使用方式能够为每位在此应用程序上工作的人员构建一组标准的测试.如果当更改了应用程序代码以后,他们所需做的工作仅仅是点击几下按钮来验证此应用程序是否依然能够通过标准测试. JUnit被用来测试代码,并且它是由能够测试不同条件的断言方法(asser			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj7EqmM.html" rel="bookmark">C&plus;&plus;语言基础-入门简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C++是个强大的语言,可以用于做别的语言做不了的工作.但是,这种强大功能是有代价的.开始使用C++时,你可能会遇到内存溢出和访问失效等问题,使程序死机.这里用最简短的篇幅介绍C++语言基础.C++语言本身有专著介绍,这种书还特别厚,所以别指望我能用三言两语说清楚.读者学完本书并使用C++ Builder一般时间之后,最后对C++语言再作更深入的了解. C++可以最充分地利用面向对象编程(OOP)的优势.OOP不只是一个新名词,而有它的实际意义,可以生成可复用的对象.新术语 对象(object),			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn72m2z.html" rel="bookmark">Java4Android之单元测试入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要介绍了如何使用 JUnit 4 提供的各种功能开展有效的单元测试,并通过一个实例演示了如何使用 Ant 执行自动化的单元测试.本文假设读者对 Eclipse 下进行 Java 开发有一定的经验,并了解 Java 5 中的注解(annotation)特性. 引言      毋庸置疑,程序员要对自己编写的代码负责,您不仅要保证它能通过编译,正常地运行,而且要满足需求和设计预期的效果.单元测试正是验证代码行为是否满足预期的有效手段之一.但不可否认,做测试是件很枯燥无趣的事情,而一遍又一遍的测试			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvnaLWM.html" rel="bookmark">请问swing做的界面该怎么使用junit做单元测试呢？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 请问swing做的界面该怎么使用junit做单元测试呢? 解决方案 FEST-Swing是一个能够与JUnit集成的GUI测试框架.你可以研究研究.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR1eaKb.html" rel="bookmark">junit测试单元测试swing 结果窗口只是闪一下就看不到了 求解。。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 junit测试单元测试swing 结果窗口只是闪一下就看不到了 求解.. 源代码: package com.Swing; import static org.junit.Assert.*; import java.awt.BorderLayout; import java.awt.Container; import java.awt.event.WindowAdapter; import java.awt.event.WindowEvent; import javax.swing.JB			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ4KKOM.html" rel="bookmark">ASP&period;NET Core学习之一 入门简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.入门简介 在学习之前,要先了解ASP.NET Core是什么?为什么?很多人学习新技术功利心很重,恨不得立马就学会了. 其实,那样做很不好,马马虎虎,联系过程中又花费非常多的时间去解决所遇到的&quot;问题&quot;,是简单的问题,对,就是简单,就是因为觉得简单被忽略的东西,恰恰这才是最重要的. 1.学习资料 首先,介绍下哪里可以获得学习资料 英文官网,最好的文档,英语得过硬 https://docs.microsoft.com/en-us/aspnet/core/ 可惜当年英语就是马马虎虎过来的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp56GDz.html" rel="bookmark" class="title">CSS教程&colon;DIV元素与SPAN元素的区别</a>
					<div>
						首先讲两个概念,一个是行内元素,一个是块级元素.行业元素是指该元素标记的内容不不会对现在的结构造成影响,属于应用样式,辅助应用样式表等作 用:而块级元素为一个块状,单独占据一行,相当于在一个该元素前后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmXwBM.html" rel="bookmark" class="title">&period;exe可执行文件无法打开问题解决方案</a>
					<div>
						电脑出现在如题所说的问题,点击我的电脑的属性弹出一个对话框说&quot;无法找到C:WINDOWSsystem32undll32.exe&quot;,后来想打开一些已经安装的软件程序却弹出一个要你选择 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLjDWb.html" rel="bookmark" class="title">我做网站排名的十四天全记录</a>
					<div>
						首先,说说这个网站,一开始是不准备做的,后来有了个普洱茶的SEO比赛,自己心里也想挑战下,就报名参加了,这次大赛,整合的是3.4个高级群的力量来做的,这些群里面有的是高手,但是参赛站不是很多,是个小遗 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlvJVz.html" rel="bookmark" class="title">经验分享&colon;做前端每天工作中最基本的法则</a>
					<div>
						文章描述:我做前端一年半. 如果从开始工作那天开始算是入行,到今天也有近一年半了.听到前端这个词,肯定有很多人脑海里浮现出男人,死板的,带着满脸执着的画面.其实不然,我是个活生生例子,嘿嘿. 现在好像 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvgO9p.html" rel="bookmark" class="title">常用的脚本编程知识点</a>
					<div>
						1.变量中字符的长度:${#VARNAME} #A='hello world' #echo ${#A}    --显示定义变量A的长度,输出结果为11 #11 2.变量赋值等: ${parameter ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAaG12M.html" rel="bookmark" class="title">SpringSide开发实战（一）：使用Eclipse让SpringSide跑起来</a>
					<div>
						自2000年Struts框架发布,到2001年底Hibernate的诞生,再到2004年Spring的流行, Java社区的开源软件哲学是:&quot;只做好一件事情,只做最擅长的事情,其他事情留给别 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxP8y7M.html" rel="bookmark" class="title">PPT制作简报技巧</a>
					<div>
						这篇稿子原是90年7月在政治大学「研究方法」研习营「信息搜集与信息组织」的教材,是个人的心得,挂上网是希望大家能给我建议和指教,文章是永远没有写完的时候,网页的好处是我有了新的学习或体验,或接到「顾客 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6kRVz.html" rel="bookmark" class="title">XP系统卸载IE浏览器的方法</a>
					<div>
						  XP系统卸载IE浏览器的方法 1.首先在开始菜单的右侧栏,找到&quot;控制面板&quot;,点击,如下图所示: 2.打开&quot;控制面板&quot;后,找到&quot;程序&quot;,点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBD1yb.html" rel="bookmark" class="title">win8怎样关闭开机启动项</a>
					<div>
						  首先按Win+R打开运行,输入msconfig回车进入系统配置. 点击启动标签,点击打开任务管理器按钮. 然后我们便能够对启动项进行关闭了.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6GwAb.html" rel="bookmark" class="title">jQuery使用fadein方法实现渐出效果实例</a>
					<div>
						 这篇文章主要介绍了jQuery使用fadein方法实现渐出效果的方法,以一个简单实例形式分析了jQuery中fadein方法的使用技巧,具有一定参考借鉴价值,需要的朋友可以参考下     本文实例讲 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72gWRp.html" rel="bookmark" class="title">win7旗舰版的防火墙能不能关闭</a>
					<div>
						  win7旗舰版如何关闭防火墙?很多朋友感到很疑惑,为什么要关闭防火墙呢?防火墙不是系统的一道安全屏障,可以保护咱们电脑的安全吗?是的,防火墙确实有保护系统的功能,但是同时,因为这种限制过多,也会导 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8N9kb.html" rel="bookmark" class="title">华硕笔记本怎么样？</a>
					<div>
						  下面给大家介绍一款非常流行笔记本--华硕n56.它配有Intel Core i7-3610QM处理器(主频2.30GHz).GT630M独立显卡(2GB显存)以及HD4000集成显卡.6GB DD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badPPwz.html" rel="bookmark" class="title">&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl;&excl; 我想将二维数组每个值导出 应该怎么做呢 如下：</a>
					<div>
						问题描述 for(inti=0;i&lt;arr.GetLength(0);i++){for(intj=0;j&lt;arr.GetLength(1);i++){xtw.WriteElementStr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY2YOM.html" rel="bookmark" class="title">mysql命令详解</a>
					<div>
						首先创建一个简单的user表CREATE TABLE `user` (`id`  int NOT NULL AUTO_INCREMENT ,`name`  varchar(255) NULL ,`se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGALX3M.html" rel="bookmark" class="title">多媒体之摄像头、相册</a>
					<div>
						网络这块要学的东西还有好多,比如套接字等,目前只是了解了AFNetworking.掌握了它对网络这块基本功能都可以实现,问题不大,等有机会再深入学习网络这块.目前先把IOS的整体模块都了解学习遍,针对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrymWM.html" rel="bookmark" class="title">【新手请教】axis的new service&lpar;&rpar;出错</a>
					<div>
						问题描述 =================================importorg.apache.axis.Constants;importorg.apache.axis.client.C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKQy6b.html" rel="bookmark" class="title">从A5学到的CMS网站盈利的方式和技巧</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 最近一直喜欢在A5上闲逛,也好好看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeO20b.html" rel="bookmark" class="title">如何在Linux上找出并删除重复的文件：FSlint</a>
					<div>
						如何在Linux上找出并删除重复的文件:FSlint 大家好,今天我们会学习如何在Linux PC或者服务器上找出和删除重复文件.这里有一款工具你可以工具自己的需要使用. 无论你是否正在使用Linux ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye5qPM.html" rel="bookmark" class="title">指点迷津&excl;&excl;&excl;（人生大转折）</a>
					<div>
						问题描述 我是今年六月份毕业的(java专业),但是我打算去深圳求职(还没拿到毕业证),不知道那边发展前途怎么样啊???求各位前辈指点一下,感激不尽.........,谢谢各位了!!! 解决方案 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnZeNM.html" rel="bookmark" class="title">OpenCascade Primitives BRep - Box</a>
					<div>
						OpenCascade Primitives BRep - Box eryar@163.com Abstract. BRep is short for Boundary Representation. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOn3rqp.html" rel="bookmark" class="title">英议员称中国低碳技术超越西方 提醒勿&OpenCurlyDoubleQuote;轻敌&rdquo;</a>
					<div>
						据7月20日出版的&lt;环球时报&gt;报道,来自执政党保守党的英国议会能源及气候变化http://www.aliyun.com/zixun/aggregation/5974.html&quot;& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7daEM.html" rel="bookmark" class="title">C&num;汉字转换拼音技术详解（高性能）&lowbar;C&num;教程</a>
					<div>
						下面将源代码贴出. 复制代码 代码如下: public static class ChineseToPinYin { private static readonly Dictionary&lt;int ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVNJBz.html" rel="bookmark" class="title">js 3种归并操作的实例代码&lowbar;javascript技巧</a>
					<div>
						第一种: 复制代码 代码如下: /**良哥的*/function merge(a, b) {    var aLen = a.length,        bLen = b.length,       ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1Zjob.html" rel="bookmark" class="title">《风声》中李冰冰的裸戏在细节中超越自我&lpar;图&rpar;</a>
					<div>
						李冰冰饰演的&quot;李宁玉&quot;受尽黄晓明饰演的日本军官&quot;武田&quot;的凌辱,游标卡尺成特殊刑具. 国庆期间,三峡在线看了谍战题材的商业大片&lt;风声&gt;.看完之后,李冰 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mqgg2Rz.html" rel="bookmark" class="title">Android 4&period;0的21项特性</a>
					<div>
						Android4.0着重于手机端,包括新的功能和新的界面改进等等,在用户体验上追求极致,小编就来逐一分析Android的主要特点,特性列表: 1.虚拟按键,增大屏幕面积同时控制手机整体大小 正如之前泄 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRdnjaz.html" rel="bookmark" class="title">javascript函数的返回方式</a>
					<div>
						问题描述 javascript函数的返回方式 刚学js,在别人的代码里面看到这样一个函数 function newOp(startMouse, startScale) { return { type: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPA63p.html" rel="bookmark" class="title">想有就有CC视频多元模块助力网络教育</a>
					<div>
						互联网技术的迅速发展,悄无声息的带动各行各业的发展,教育行业也是如此.从传统的课堂学习,到创新式的网络教育,&quot;人人皆学.处处可学.时时能学&quot;不再是奢求,新式教学环境已经彻底走进千家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zengd7b.html" rel="bookmark" class="title">再见，南邮！别了，南京！</a>
					<div>
						       &quot;光阴似箭,日月如梭&quot;,又一个三年就这样匆匆地过去了.回望过去三年我在南邮的学习生活,所有的快乐.所取得的成绩以及曾经经历过的困难与挫折,所有的这一切都如同一部电影一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9vxkRp.html" rel="bookmark" class="title">新型城镇化：智慧城市成亮点</a>
					<div>
						&quot;十三五&quot;规划&lt;建议&gt;中提出,到2020年,户籍人口城镇化率加快提高.提高城镇化率,人往哪里去.钱从哪里来,以及如何实现产城融合,是绕不开的重要课题. 随着我国城镇化的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK30NAb.html" rel="bookmark" class="title">1、cocos2d-x环境安装</a>
					<div>
						﻿﻿ 1 所需软件 2 安装python-2.7.8.amd64.msi 注意将其中的有一步设置,Add python.exe to path 设置python的环境变量 3 解压cocos2d-x- ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
